(*
Problem 01 - Mode Sort

This problem is to sort an input string of N characters, N<1000000, based on the number of times a character occurs in the input.  The most frequently occurring character should be sorted to the front of the string, followed by the next most frequently occurring character, etc.  For characters occurring the same number of times, the character that occurs first in the input should be sorted to the front.

Header specification

pascal OSErr ModeSort( const FSSpec* infile, const FSSpec* outfile );

Input specification

The infile input file contains the characters.  Input characters other than those printable low ascii characters c, 0x20<c<0x7f, must be ignored.

Output specification

The outfile must be created and then filled with the sorted characters.  It's final length should be exactly the same as the count of characters in the allowed range (0x20<c<0x7f) (which may be shorter than the infile file length).

Sample input

abcdefghabbcccdddeee
or
012345678911234567892123456789312345678941234567895123456789612345678971234567891

Sample output

ccccddddeeeebbbaafgh
or
111111111122222222233333333344444444455555555566666666677777777788888888999999990
*)

unit Solution;

interface

// Do not modify the interface

	uses
		Types, Files;
		
	function ModeSort( const infile, outfile: FSSpec ): OSErr;

implementation

// Fill in your solution and then submit this folder

// Team Name: Example Solution
// 9 minutes

	function ProblemFileRead( const infile: FSSpec; var data: Handle ): OSErr; external;
	function ProblemFileWrite( const outfile: FSSpec; data: Handle ): OSErr; external;

	function ModeSort( const infile, outfile: FSSpec ): OSErr;
		var
			err: OSErr;
			data: Handle;
			counts: array[0..255] of longint;
			firstpos: array[0..255] of longint;
			i, len: longint;
			what, best: integer;
	begin
		err := ProblemFileRead( infile, data );
		if err = noErr then begin
			for i := 0 to 255 do begin
				counts[i] := 0;
				firstpos[i] := 0;
			end;
			for i := 0 to GetHandleSize( data ) - 1 do begin
				what := band(Ptr(longint(data^)+i)^, $00FF);
				if (32 < what) & (what < 127) then begin
					if counts[what] = 0 then begin
						firstpos[what] := i;
					end;
					Inc(counts[what]);
				end;
			end;
			len := 0;
			while true do begin
				best := -1;
				for what := 0 to 255 do begin
					if counts[what] > 0 then begin
						if best = -1 then begin
							best := what;
						end else begin
							if counts[what] > counts[best] then begin
								best := what;
							end else if (counts[what] = counts[best]) & (firstpos[what] < firstpos[best]) then begin
								best := what;
							end;
						end;
					end;
				end;
				if best = -1 then begin
					leave;
				end;
				i := counts[best];
				counts[best] := 0;
				while i > 0 do begin
					Ptr(longint(data^)+len)^ := best;
					Inc(len);
					Dec(i);
				end;
			end;
			SetHandleSize( data, len );
			err := ProblemFileWrite( outfile, data );
			DisposeHandle( data );
		end;
		ModeSort := err;
	end;
	
end.
